/* A lexical scanner generated by flex */

/* Scanner skeleton version:
 * $Header: /home/daffy/u0/vern/flex/RCS/flex.skl,v 2.91 96/09/10 16:58:48 vern Exp $
 */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5

#include <stdio.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>
#include <unistd.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#if __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef __TURBOC__
 #pragma warn -rch
 #pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state *YY_BUFFER_STATE;

extern int yyleng;
extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yyless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_size_t;


struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2
	};

static YY_BUFFER_STATE yy_current_buffer = 0;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;

static int yy_n_chars;		/* number of characters read into yy_ch_buf */


int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart YY_PROTO(( FILE *input_file ));

void yy_switch_to_buffer YY_PROTO(( YY_BUFFER_STATE new_buffer ));
void yy_load_buffer_state YY_PROTO(( void ));
YY_BUFFER_STATE yy_create_buffer YY_PROTO(( FILE *file, int size ));
void yy_delete_buffer YY_PROTO(( YY_BUFFER_STATE b ));
void yy_init_buffer YY_PROTO(( YY_BUFFER_STATE b, FILE *file ));
void yy_flush_buffer YY_PROTO(( YY_BUFFER_STATE b ));
#define YY_FLUSH_BUFFER yy_flush_buffer( yy_current_buffer )

YY_BUFFER_STATE yy_scan_buffer YY_PROTO(( char *base, yy_size_t size ));
YY_BUFFER_STATE yy_scan_string YY_PROTO(( yyconst char *yy_str ));
YY_BUFFER_STATE yy_scan_bytes YY_PROTO(( yyconst char *bytes, int len ));

static void *yy_flex_alloc YY_PROTO(( yy_size_t ));
static void *yy_flex_realloc YY_PROTO(( void *, yy_size_t ));
static void yy_flex_free YY_PROTO(( void * ));

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)

typedef unsigned char YY_CHAR;
FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;
typedef int yy_state_type;
extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state YY_PROTO(( void ));
static yy_state_type yy_try_NUL_trans YY_PROTO(( yy_state_type current_state ));
static int yy_get_next_buffer YY_PROTO(( void ));
static void yy_fatal_error YY_PROTO(( yyconst char msg[] ));

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 57
#define YY_END_OF_BUFFER 58
static yyconst short int yy_accept[283] =
    {   0,
        0,    0,    0,    0,   58,   56,    2,    3,    1,   56,
       54,   54,   54,   48,   56,   38,   54,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       54,   57,   57,    2,    1,    0,   41,   42,   43,    0,
        0,   48,   48,   48,    0,    0,   40,    0,   38,    0,
        0,    0,    0,    0,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   38,    0,    0,    0,   55,    0,    0,
       44,    0,    0,   48,    0,   48,    0,    0,    0,   39,

        0,    0,    0,    0,    0,   45,    0,    0,    0,   38,
       38,   38,   38,   38,   13,   38,   38,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   19,   38,
       38,   38,   21,   38,   38,   38,   38,   38,   38,   38,
       38,   38,    0,    0,    0,    0,   47,   49,    0,    0,
        0,   53,    0,    0,    0,   50,    0,    0,    0,    0,
        0,    0,   38,   38,   38,    0,   25,   38,   14,   38,
       38,   38,   38,   38,   38,   17,   38,   38,   38,   38,
       38,   38,   38,   38,    0,   32,   38,   38,   38,   23,
        7,   38,   38,   38,    0,    0,   51,    4,    0,    0,

        0,   46,   38,   38,   38,   11,   15,   38,   10,   38,
       38,    8,   38,   38,   38,   38,   38,   38,   38,   38,
       38,    0,   34,   22,   38,    0,   36,    0,   37,   52,
        0,   24,   12,   38,   16,   10,   38,   38,   38,   38,
       38,   38,   38,   20,   38,    0,   31,   38,   38,    9,
       38,   38,   38,   38,   18,   38,   38,    0,   30,   33,
       38,    0,   26,    5,   38,   38,    0,   29,    6,   33,
       38,   38,   38,   38,   38,   27,    0,   35,   38,    0,
       28,    0
    } ;

static yyconst int yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    1,    1,    4,    1,    4,    1,    5,    6,
        7,    8,    9,    8,    9,   10,    8,   11,   11,   12,
       11,   11,   11,   11,   11,   11,   11,    1,    1,   13,
       14,   15,    1,    1,   16,   16,   16,   16,   17,   16,
       16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
       16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
       18,    1,   19,    8,   20,    1,   21,   22,   23,   24,

       25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
       35,   36,   37,   38,   39,   40,   41,   42,   43,   44,
       45,   46,   47,    8,   48,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst int yy_meta[49] =
    {   0,
        1,    2,    3,    1,    1,    1,    4,    1,    1,    1,
        5,    5,    1,    6,    7,    8,    8,    1,    9,    5,
        8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
        8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
        8,    8,    8,    8,    8,    8,    1,   10
    } ;

static yyconst short int yy_base[306] =
    {   0,
        0,    0,  884,  883,  926, 1093,  923, 1093,    0,   47,
       49, 1093,   42,   45,   56,  904,   93,   40,   43,   41,
       45,   47,   48,   52,   87,   89,  107,  109,   54,   57,
       87, 1093,  875,  911,    0,  115, 1093, 1093, 1093,  117,
      132,  137,  146,  155,  144,  143, 1093,  166,  879,  878,
      883,  186,  234,  282,  153,   90,  144,   49,   95,  111,
      155,  150,  225,  226,  230,  231,  159,  236,  235,  237,
      238,  239,  311,  242,  312,  245,  251,  315,  313,  314,
      316,  252,  113,  317,  338,  341,  848, 1093,  343,  352,
     1093,  355,  362,  355,  337,  359,  371,  375,  381, 1093,

      385,    0,  405,  414,  453, 1093,  419,  501,  549,  359,
      356,  406,  428,  407,  874,  365,  409,  372,  164,  377,
      412,  378,  415,  425,  430,  424,   55,  427,  869,  416,
      454,  336,  867,  474,  458,  459,  462,  417,  540,  463,
      541,  545,  569,  571,  573,  575, 1093, 1093,  580,  596,
      589, 1093,  605,  866,  625, 1093,  582,  673,  634,  721,
      865,  603,  472,  574,  465,  608, 1093,  466,  860,  468,
      475,  550,  604,  260,  621,  855,  582,  626,  627,  630,
      469,  559,  629,  631,  655, 1093,  639,  692,  664,  795,
      756,  632,  699,  712,  735,  740, 1093, 1093,  788,  692,

      687, 1093,  742,  642,  665,  650,  646,  676,  744,  677,
      683,  644,  729,  679,  730,  687,  733,  693,  732,  764,
      738,  769, 1093,  640,  731,  771, 1093,  776, 1093, 1093,
      807, 1093,  546,  741,  500,  783,  779,  760,  791,  780,
      792,  797,  796,  423,  818,  816, 1093,  808,  809,  379,
      839,  814,  803,  593,  375,  844,  805,  846, 1093,  851,
      811,  854, 1093,  340,  838,  835,  859, 1093,  254,  830,
      843,  846,  849,  870,  854,  157,  875, 1093,  880,  889,
     1093, 1093,  900,  910,  919,  926,  930,  938,  947,  955,
      964,  971,  978,  985,  993, 1003, 1012, 1019, 1028, 1035,

     1043, 1053, 1063, 1072, 1082
    } ;

static yyconst short int yy_def[306] =
    {   0,
      282,    1,  283,  283,  282,  282,  282,  282,  284,  282,
      285,  282,  282,  282,  286,  287,  288,  287,  287,  287,
      287,  287,  287,  287,  287,  287,  287,  287,  287,  287,
      289,  282,  290,  282,  284,  282,  282,  282,  282,  291,
      292,  282,  282,  282,  282,  293,  282,  294,  287,  287,
      295,  282,  296,  282,  287,  287,  287,  287,  287,  287,
      287,  287,  287,  287,  287,  287,  287,  287,  287,  287,
      287,  287,  287,  287,  287,  287,  287,  287,  287,  287,
      287,  287,  287,  287,  297,  298,  290,  282,  299,  282,
      282,  292,  292,  282,  282,  282,  300,  282,  294,  282,

      294,  301,  302,  295,  296,  282,  105,  282,  303,  287,
      287,  287,  287,  287,  287,  287,  287,  287,  287,  287,
      287,  287,  287,  287,  287,  287,  287,  287,  287,  287,
      287,  287,  287,  287,  287,  287,  287,  287,  287,  287,
      287,  287,  304,  282,  298,  298,  282,  282,  299,  299,
      300,  282,  300,  301,  302,  282,  155,  305,  295,  303,
      282,  160,  287,  287,  287,  282,  282,  287,  287,  287,
      287,  287,  287,  287,  287,  287,  287,  287,  287,  287,
      287,  287,  287,  287,  282,  282,  287,  287,  287,  287,
      287,  287,  287,  287,  304,  304,  282,  282,  305,  282,

      199,  282,  287,  287,  287,  287,  287,  287,  287,  287,
      287,  287,  287,  287,  287,  287,  287,  287,  287,  287,
      287,  282,  282,  287,  287,  282,  282,  282,  282,  282,
      282,  282,  287,  287,  287,  282,  287,  287,  287,  287,
      287,  287,  287,  287,  287,  282,  282,  287,  287,  287,
      287,  287,  287,  287,  287,  287,  287,  282,  282,  287,
      287,  282,  282,  287,  287,  287,  282,  282,  287,  282,
      287,  287,  287,  287,  287,  287,  282,  282,  287,  282,
      282,    0,  282,  282,  282,  282,  282,  282,  282,  282,
      282,  282,  282,  282,  282,  282,  282,  282,  282,  282,

      282,  282,  282,  282,  282
    } ;

static yyconst short int yy_nxt[1142] =
    {   0,
        6,    7,    8,    9,   10,   11,   12,   12,   12,   13,
       14,   14,   15,   12,    6,   16,   16,   17,   12,    6,
       18,   16,   19,   20,   16,   21,   22,   16,   23,   16,
       16,   24,   16,   16,   16,   25,   16,   26,   27,   28,
       29,   30,   16,   16,   16,   16,   31,   12,   36,   36,
       40,   40,   42,   42,   43,   44,   44,   46,   46,   50,
       50,   45,   50,   56,   50,   59,   50,   50,   50,   45,
       47,   50,   64,   50,   50,   60,   50,   57,   62,   55,
       65,   63,   61,   58,  180,   84,  114,   83,   85,   85,
       37,   38,   39,   51,   52,   52,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   50,   51,   50,   50,
       54,   66,   51,   72,   50,   67,   36,   36,   40,   40,
      115,   68,  111,   73,   69,   70,   50,   71,   50,   74,
       50,   75,   50,   90,   90,   76,   80,   81,   91,   51,
       51,  141,   77,   78,   46,   46,   82,   42,   42,   79,
      116,   93,   95,   45,   96,   96,   94,   94,   37,   38,
       39,   45,   45,   50,   43,   44,   44,   98,   98,   50,
       45,   45,   50,  110,   50,  117,   50,  112,   50,   45,
      100,  125,  113,   50,  118,  101,   51,   52,   52,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,  102,

       51,  103,  103,   51,  172,   51,  103,  103,  103,  103,
      103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
      103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
      103,  103,   51,   51,   51,  104,  104,   51,   51,   51,
       51,   51,   51,   51,   50,   50,   51,  102,   51,   50,
       50,   51,  106,  107,   50,   50,   50,   50,   50,  121,
      119,   50,  132,  123,   50,  122,  120,  126,  124,  127,
       50,   50,  140,   50,  130,  135,  128,  129,  134,   50,
       51,   51,   51,  108,  108,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,  102,   51,  109,  109,   51,

      211,   51,  109,  109,  109,  109,  109,  109,  109,  109,
      109,  109,  109,  109,  109,  109,  109,  109,  109,  109,
      109,  109,  109,  109,  109,  109,  109,  109,   51,   51,
       50,   50,   50,   50,   50,   50,   50,  137,  138,   85,
       85,  142,  144,  144,   90,   90,  139,   96,   96,  148,
      131,  133,  136,   90,   90,   50,   90,   90,  148,   50,
      146,   91,  150,  282,  282,   94,   94,  184,  282,   96,
       96,   45,   98,   98,   93,   50,   98,   98,   50,   45,
      164,   93,   98,   98,   50,  152,  282,  282,  147,  152,
      153,   50,  163,  171,   50,  100,   50,   50,   50,  282,

      101,  173,  175,  169,  101,   51,  104,  104,   51,   51,
       51,   51,   51,   51,   51,  104,  104,   51,  102,   51,
       51,   51,   51,  156,  157,   50,   50,  102,   50,  166,
      166,   50,  156,  167,   50,   50,   50,  282,  174,  176,
      182,  170,   50,   50,   50,  165,   50,   50,  168,   50,
      190,   51,   51,   51,  104,  104,   51,   51,   51,   51,
       51,   51,   51,  177,  181,   51,  102,   51,  179,  178,
       51,  106,  107,   50,  183,  185,  185,   50,   50,  186,
      187,   50,   50,  203,   50,   50,  189,   50,   50,  205,
      206,   50,  207,   50,   50,  208,  192,  217,  188,   51,

       51,   51,  108,  108,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,  102,   51,  158,  158,   51,   50,
       51,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,   51,   51,   51,
      159,  159,   51,   51,   51,   51,   51,   51,   51,   50,
       50,   51,  102,   51,   50,   50,   51,  161,  162,   50,
      144,  144,  144,  144,  144,  144,  282,  282,   50,  218,
      193,   90,   90,   51,   51,  191,  148,  194,  196,  209,
       98,   98,  146,   50,  146,   51,   51,  282,  282,  150,

      282,   50,  282,  152,   51,   51,  282,  282,  153,  166,
      166,  204,   50,  167,  266,  150,  197,  213,  197,  282,
      147,  282,  282,   50,  153,   51,  104,  104,   51,   51,
       51,   51,   51,   51,   51,  159,  159,   51,  102,   51,
       50,  210,   51,  156,  157,   50,   50,  102,   50,   50,
       50,   50,  200,  215,  216,  220,  185,  185,   50,   50,
      186,   50,  233,   50,  212,   50,  214,  221,  219,   50,
      225,   51,   51,   51,  159,  159,   51,   51,   51,   51,
       51,   51,   51,   50,   50,   51,  102,   51,   51,   51,
       51,  200,  201,  222,  222,   50,   50,  223,   50,  224,

      226,  226,   50,  238,  227,  282,   50,  235,  234,  242,
      230,   50,   50,  228,  228,  237,  240,  229,   50,   51,
       51,   51,  159,  159,   51,   51,   51,   51,   51,   51,
       51,   50,  244,   51,  102,   51,  144,  144,   51,  161,
      162,  282,  282,  231,  231,  236,  236,  232,   50,   50,
       50,   50,   50,  239,  196,  243,  245,   50,  248,  196,
       50,   50,  249,   50,  241,  246,  246,   51,   51,  247,
      222,  222,  226,  226,  223,   50,  227,  228,  228,   50,
      250,  229,  197,   50,  236,  236,  252,  282,   51,  159,
      159,   51,   51,   51,   51,   51,   51,   51,   50,   50,

       51,  102,   51,  251,  254,   51,  200,  201,  231,  231,
       50,   50,  232,  253,   50,   50,   50,  246,  246,  258,
      258,  247,   50,  259,   50,  255,  257,   50,   50,  261,
       50,  270,  270,   50,   51,   51,  256,   50,  264,  260,
      262,  262,  265,  269,  263,  267,  267,  258,  258,  268,
      271,  259,  270,  270,   50,  262,  262,   50,   50,  263,
      267,  267,   50,   50,  268,   50,  272,  274,   50,  273,
       50,  277,  277,   50,   50,  278,  277,  277,  279,   50,
      278,  280,  280,  202,  198,  281,   50,  275,   50,   50,
      280,  280,  276,   50,  281,   88,  102,   50,   50,   50,

       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
       35,   35,   34,   35,   35,   35,   35,   35,   35,   35,
       41,   41,   88,   50,   34,  282,   41,   48,   48,   33,
       33,  282,   48,   48,   49,  282,  282,   49,   53,   53,
       53,   53,   53,  282,   53,   53,  282,   53,   86,   86,
      282,  282,  282,  282,   86,   87,   87,   87,   87,   87,
       87,   87,   87,   87,   87,   89,   89,  282,  282,  282,
      282,   89,   92,   92,   92,   92,  282,  282,   92,   97,
       97,  282,  282,  282,  282,   97,   99,   99,  282,   99,
      282,   99,   99,   51,   51,   51,   51,   51,   51,   51,

       51,  282,   51,  105,  105,  105,  105,  105,  105,  105,
      105,  105,  105,  143,  143,  282,  282,  282,  282,  143,
      145,  145,  282,  145,  282,  282,  145,  282,  145,  149,
      149,  149,  149,  282,  282,  149,  151,  151,  282,  151,
      282,  151,  151,  154,  154,  154,  154,  154,  154,  154,
      154,  282,  154,  155,  155,  155,  155,  155,  155,  155,
      155,  155,  155,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  195,  195,  282,  195,  282,  282,  195,
      282,  195,  199,  199,  199,  199,  199,  199,  199,  199,
      199,  199,    5,  282,  282,  282,  282,  282,  282,  282,

      282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
      282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
      282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
      282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
      282
    } ;

static yyconst short int yy_chk[1142] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,   10,   10,
       11,   11,   13,   13,   14,   14,   14,   15,   15,   18,
       20,   14,   19,   19,   21,   20,   22,   23,   58,   14,
       15,   24,   24,   29,  127,   20,   30,   19,   22,   18,
       24,   23,   21,   19,  127,   30,   58,   29,   31,   31,
       10,   10,   10,   17,   17,   17,   17,   17,   17,   17,

       17,   17,   17,   17,   17,   17,   25,   17,   26,   56,
       17,   25,   17,   26,   59,   25,   36,   36,   40,   40,
       59,   25,   56,   26,   25,   25,   27,   25,   28,   27,
       60,   27,   83,   41,   41,   27,   28,   28,   41,   17,
       17,   83,   27,   27,   46,   46,   28,   42,   42,   27,
       60,   41,   45,   42,   45,   45,   43,   43,   36,   36,
       36,   42,   43,   57,   44,   44,   44,   48,   48,   62,
       43,   44,   55,   55,   61,   61,  276,   57,   67,   44,
       48,   67,   57,  119,   62,   48,   52,   52,   52,   52,
       52,   52,   52,   52,   52,   52,   52,   52,   52,   52,

       52,   52,   52,   52,  119,   52,   52,   52,   52,   52,
       52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
       52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
       52,   52,   52,   52,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   63,   64,   53,   53,   53,   65,
       66,   53,   53,   53,   69,   68,   70,   71,   72,   64,
       63,   74,   74,   65,   76,   64,   63,   68,   66,   69,
       77,   82,   82,  269,   72,   77,   70,   71,   76,  174,
       53,   53,   54,   54,   54,   54,   54,   54,   54,   54,
       54,   54,   54,   54,   54,   54,   54,   54,   54,   54,

      174,   54,   54,   54,   54,   54,   54,   54,   54,   54,
       54,   54,   54,   54,   54,   54,   54,   54,   54,   54,
       54,   54,   54,   54,   54,   54,   54,   54,   54,   54,
       73,   75,   79,   80,   78,   81,   84,   79,   80,   85,
       85,   84,   86,   86,   89,   89,   81,   95,   95,   89,
       73,   75,   78,   90,   90,  132,   92,   92,   90,  264,
       86,   92,   89,   93,   93,   94,   94,  132,   93,   96,
       96,   94,   97,   97,   92,  111,   98,   98,  110,   94,
      111,   93,   99,   99,  116,   97,  101,  101,   86,   98,
       97,  118,  110,  118,  255,   99,  120,  122,  250,  101,

       99,  120,  122,  116,  101,  103,  103,  103,  103,  103,
      103,  103,  103,  103,  103,  104,  104,  103,  103,  103,
      107,  107,  103,  103,  103,  112,  114,  104,  117,  113,
      113,  121,  104,  113,  123,  130,  138,  107,  121,  123,
      130,  117,  244,  126,  124,  112,  128,  113,  114,  125,
      138,  103,  103,  105,  105,  105,  105,  105,  105,  105,
      105,  105,  105,  124,  128,  105,  105,  105,  126,  125,
      105,  105,  105,  131,  131,  134,  134,  135,  136,  134,
      135,  137,  140,  163,  165,  168,  137,  170,  181,  165,
      168,  163,  170,  134,  171,  171,  140,  181,  136,  105,

      105,  108,  108,  108,  108,  108,  108,  108,  108,  108,
      108,  108,  108,  108,  108,  108,  108,  108,  108,  235,
      108,  108,  108,  108,  108,  108,  108,  108,  108,  108,
      108,  108,  108,  108,  108,  108,  108,  108,  108,  108,
      108,  108,  108,  108,  108,  108,  108,  108,  108,  109,
      109,  109,  109,  109,  109,  109,  109,  109,  109,  139,
      141,  109,  109,  109,  142,  233,  109,  109,  109,  172,
      143,  143,  144,  144,  145,  145,  146,  146,  182,  182,
      141,  149,  149,  157,  157,  139,  149,  142,  143,  172,
      151,  151,  145,  164,  146,  109,  109,  150,  150,  149,

      157,  177,  150,  151,  162,  162,  153,  153,  151,  166,
      166,  164,  254,  166,  254,  150,  143,  177,  144,  153,
      145,  162,  146,  173,  153,  155,  155,  155,  155,  155,
      155,  155,  155,  155,  155,  159,  159,  155,  155,  155,
      175,  173,  155,  155,  155,  178,  179,  159,  183,  180,
      184,  192,  159,  179,  180,  184,  185,  185,  187,  224,
      185,  204,  204,  212,  175,  207,  178,  187,  183,  206,
      192,  155,  155,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  189,  205,  158,  158,  158,  201,  201,
      158,  158,  158,  188,  188,  208,  210,  188,  214,  189,

      193,  193,  211,  211,  193,  201,  216,  208,  205,  216,
      200,  188,  218,  194,  194,  210,  214,  194,  193,  158,
      158,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  194,  218,  160,  160,  160,  195,  195,  160,  160,
      160,  196,  196,  203,  203,  209,  209,  203,  213,  215,
      225,  219,  217,  213,  195,  217,  219,  221,  221,  196,
      234,  203,  225,  209,  215,  220,  220,  160,  160,  220,
      222,  222,  226,  226,  222,  191,  226,  228,  228,  238,
      234,  228,  195,  220,  236,  236,  238,  196,  199,  199,
      199,  199,  199,  199,  199,  199,  199,  199,  237,  240,

      199,  199,  199,  237,  240,  199,  199,  199,  231,  231,
      239,  241,  231,  239,  190,  243,  242,  246,  246,  245,
      245,  246,  253,  245,  257,  241,  243,  248,  249,  249,
      261,  270,  270,  252,  199,  199,  242,  245,  252,  248,
      251,  251,  253,  257,  251,  256,  256,  258,  258,  256,
      261,  258,  260,  260,  266,  262,  262,  265,  251,  262,
      267,  267,  271,  256,  267,  272,  265,  271,  273,  266,
      260,  274,  274,  275,  176,  274,  277,  277,  275,  169,
      277,  279,  279,  161,  154,  279,  133,  272,  129,  274,
      280,  280,  273,  115,  280,   87,   51,   50,   49,  279,

      283,  283,  283,  283,  283,  283,  283,  283,  283,  283,
      284,  284,   34,  284,  284,  284,  284,  284,  284,  284,
      285,  285,   33,   16,    7,    5,  285,  286,  286,    4,
        3,    0,  286,  286,  287,    0,    0,  287,  288,  288,
      288,  288,  288,    0,  288,  288,    0,  288,  289,  289,
        0,    0,    0,    0,  289,  290,  290,  290,  290,  290,
      290,  290,  290,  290,  290,  291,  291,    0,    0,    0,
        0,  291,  292,  292,  292,  292,    0,    0,  292,  293,
      293,    0,    0,    0,    0,  293,  294,  294,    0,  294,
        0,  294,  294,  295,  295,  295,  295,  295,  295,  295,

      295,    0,  295,  296,  296,  296,  296,  296,  296,  296,
      296,  296,  296,  297,  297,    0,    0,    0,    0,  297,
      298,  298,    0,  298,    0,    0,  298,    0,  298,  299,
      299,  299,  299,    0,    0,  299,  300,  300,    0,  300,
        0,  300,  300,  301,  301,  301,  301,  301,  301,  301,
      301,    0,  301,  302,  302,  302,  302,  302,  302,  302,
      302,  302,  302,  303,  303,  303,  303,  303,  303,  303,
      303,  303,  303,  304,  304,    0,  304,    0,    0,  304,
        0,  304,  305,  305,  305,  305,  305,  305,  305,  305,
      305,  305,  282,  282,  282,  282,  282,  282,  282,  282,

      282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
      282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
      282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
      282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
      282
    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "sketch.l"
#define INITIAL 0
#line 2 "sketch.l"

/* sketch.l
   Copyright (C) 2005,2006,2007,2008 Eugene K. Ressler, Jr.

This file is part of Sketch, a small, simple system for making 
3d drawings with LaTeX and the PSTricks or TikZ package.

Sketch is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

Sketch is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sketch; see the file COPYING.txt.  If not, see
http://www.gnu.org/copyleft */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "geometry.h"
#include "symbol.h"
#include "expr.h"
#include "parse.h"
#include "y.tab.h"
#include "error.h"
#include "opts.h"

#if defined(_WIN32) && !defined fileno
#define fileno(F) _fileno(F)
#pragma warning(disable:4102)
#endif

// undo the safety net in polygon.h so flex scanner can use these library functions
#undef malloc
#undef realloc
#undef free
#undef strdup

SRC_LINE line;

#define MAX_INPUT_DEPTH 10

struct {
 YY_BUFFER_STATE buffer_state;
 SRC_LINE line;
} input_stack[MAX_INPUT_DEPTH];
int input_stack_ptr = 0;

#define INIT_SPECIAL_BUF_SIZE 40

void update_line_number(void)
{
  int i;

  for (i = 0; yytext[i]; i++)
    if (yytext[i] == '\n')
      line.number++;
}

#define inputdirective 1

#line 780 "lex.yy.c"

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO(( void ));
#else
extern int yywrap YY_PROTO(( void ));
#endif
#endif

#ifndef YY_NO_UNPUT
static void yyunput YY_PROTO(( int c, char *buf_ptr ));
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO(( char *, yyconst char *, int ));
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen YY_PROTO(( yyconst char * ));
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput YY_PROTO(( void ));
#else
static int input YY_PROTO(( void ));
#endif
#endif

#if YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int *yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO(( int new_state ));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO(( void ));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO(( void ));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( yy_current_buffer->yy_is_interactive ) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
		  && ferror( yyin ) ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yylex YY_PROTO(( void ))
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

YY_DECL
	{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;

#line 74 "sketch.l"


#line 934 "lex.yy.c"

	if ( yy_init )
		{
		yy_init = 0;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yy_start )
			yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! yy_current_buffer )
			yy_current_buffer =
				yy_create_buffer( yyin, YY_BUF_SIZE );

		yy_load_buffer_state();
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yy_start;
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				yy_last_accepting_state = yy_current_state;
				yy_last_accepting_cpos = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 283 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 1093 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = yy_last_accepting_cpos;
			yy_current_state = yy_last_accepting_state;
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;


do_action:	/* This label is used only to access EOF actions. */


		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = yy_hold_char;
			yy_cp = yy_last_accepting_cpos;
			yy_current_state = yy_last_accepting_state;
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 76 "sketch.l"
/* comment; do nothing */
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 78 "sketch.l"
/* white space; do nothing */ 
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 80 "sketch.l"
{ 
  line.number++; 
}
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 84 "sketch.l"
{ /* [<stuff>=<stuff>] */
  // elide the brackets
  yylval.str = safe_malloc(yyleng + 1 - 2);
  str_slice(yylval.str, yyleng + 1 - 2, yytext, 1, -1);
  return OPTS_STR;
}
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 91 "sketch.l"
{
	return LANGUAGE;
}
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 95 "sketch.l"
{
	return PSTRICKS;
}
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 99 "sketch.l"
{
	return TIKZ;
}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 103 "sketch.l"
{
        return LaTeX;
}
	YY_BREAK
case 9:
YY_RULE_SETUP
#line 107 "sketch.l"
{
        return ConTeXt;
} 
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 111 "sketch.l"
{
  update_line_number();
  BEGIN(inputdirective);
}
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 116 "sketch.l"
{
  return CURVE;
}
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 120 "sketch.l"
{
  return CAMERA;
}
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 124 "sketch.l"
{
  return DEF;
}
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 128 "sketch.l"
{
  return DOTS;
}
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 132 "sketch.l"
{
  return FRAME;
}
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 136 "sketch.l"
{
  return GLOBAL;
}
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 140 "sketch.l"
{
  return LINE;
}
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 144 "sketch.l"
{
  return POLYGON;
}
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 148 "sketch.l"
{
  return PUT;
}
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 152 "sketch.l"
{
  return REPEAT;
}
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 156 "sketch.l"
{
  return SET;
}
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 160 "sketch.l"
{
  return SWEEP;
}
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 164 "sketch.l"
{
  return THEN;
}
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 168 "sketch.l"
{
  update_line_number();
  return ATAN2;
}
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 173 "sketch.l"
{
  update_line_number();
  return COS;
}
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 178 "sketch.l"
{
  update_line_number();
  return INVERSE;
}
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 183 "sketch.l"
{
  return PICTUREBOX;
}
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 187 "sketch.l"
{
  update_line_number();
  return PERSPECTIVE;
}
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 192 "sketch.l"
{
  update_line_number();
  return PROJECT;
}
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 197 "sketch.l"
{
  update_line_number();
  return ROTATE;
}
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 202 "sketch.l"
{
  update_line_number();
  return SCALE;
}
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 207 "sketch.l"
{
  update_line_number();
  return SIN;
}
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 212 "sketch.l"
{  
  char *rtn;
  int max_rtn_len, delim, i, ch;

  update_line_number();

  max_rtn_len = INIT_SPECIAL_BUF_SIZE - 1;
  rtn = safe_malloc(max_rtn_len + 1);
  i = 0;

  delim = input();

  if (delim == EOF) {
    err(line, "expected special text, found end of file");
  }
  else {
    while ((ch = input()) != delim && ch != EOF) {
      if (ch == '\n')
        ++line.number;
      if (i == max_rtn_len) {
        max_rtn_len *= 2;
        rtn = safe_realloc(rtn, max_rtn_len + 1);
      }
      rtn[i++] = ch;
    }
    if (ch != delim)
      err(line, "missing end delimeter '%c' in special", delim);
  }
  rtn[i] = '\0';
  yylval.str = rtn;
  return SPECIAL;
}
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 245 "sketch.l"
{
  update_line_number();
  return SQRT;
}
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 250 "sketch.l"
{
  update_line_number();
  return TRANSLATE;
}
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 255 "sketch.l"
{
  update_line_number();
  return UNIT;
}
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 260 "sketch.l"
{
  update_line_number();
  return VIEW;
}
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 265 "sketch.l"
{ 
  str_slice(yylval.name, sizeof yylval.name, yytext, 0, sizeof yylval.name);
  return ID; 
}
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 270 "sketch.l"
{ 
  str_slice(yylval.name, sizeof yylval.name, yytext, 1, -1);
  return ANGLE_ID; 
}
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 275 "sketch.l"
{
  return EMPTY_ANGLE;
}
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 279 "sketch.l"
{
  update_line_number();
  yylval.index = 0;
  return TICK;
}
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 285 "sketch.l"
{
  update_line_number();
  yylval.index = 1;
  return TICK;
}
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 291 "sketch.l"
{
  update_line_number();
  yylval.index = 2;
  return TICK;
}
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 297 "sketch.l"
{ 
  str_slice(yylval.name, sizeof yylval.name, yytext, 1, -1);
  return PAREN_ID; 
}
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 302 "sketch.l"
{ 
  str_slice(yylval.name, sizeof yylval.name, yytext, 1, -1);
  return BRACKET_ID; 
}
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 307 "sketch.l"
{ 
  str_slice(yylval.name, sizeof yylval.name, yytext, 2, -2);
  return DBL_BRACKET_ID; 
}
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 312 "sketch.l"
{ 
  str_slice(yylval.name, sizeof yylval.name, yytext, 1, -1);
  return CURLY_ID; 
}
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 317 "sketch.l"
{ 
  if (sscanf(yytext, FLOAT_SCAN_FMT, &yylval.flt) != 1) {
    err(line, "numeric constant %s could not be converted (probably out of range)", yytext);
    yylval.flt = 0;
  }
  return NUM;
}
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 325 "sketch.l"
{
  warn(line, "found parenthesized identifier '%s'; delete space if you meant a point ref", yytext);
  yyless(1);
  return '(';
}
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 331 "sketch.l"
{
  warn(line, "found id in brackets '%s'; delete space if you meant a vector ref", yytext);
  yyless(1);
  return '[';
}
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 337 "sketch.l"
{
  warn(line, "found id in braces '%s'; delete space if you meant a drawable ref", yytext);
  yyless(1);
  return '{';
}
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 343 "sketch.l"
{
  warn(line, "found id in double-brackets '%s'; delete space if you meant a transform ref", yytext);
  yyless(1);
  return '[';
}
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 349 "sketch.l"
{
  warn(line, "found id in angle-brackets '%s'; delete space if you meant a tag ref", yytext);
  yyless(1);
  return '<';
}
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 355 "sketch.l"
{ 
  return yytext[0];	
}
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 359 "sketch.l"
{

  FILE *f;
  char buf[1024];
  int i;

  if (line.file_name[0] != '/' && line.file_name[0] != '\\')
    i = str_last_occurance(line.file_name, "/\\");
  if (i >= 0) {
    str_slice(buf, sizeof buf, line.file_name, 0, i + 1);
  }
  else {
    buf[0] = '\0';
  }

  i = strlen(buf);
  str_slice(&buf[i], sizeof buf - i, yytext, 1, -1);

  if (input_stack_ptr >= MAX_INPUT_DEPTH) {
    err(line, "inputs nested too deeply (file '%s' ignored)", buf);
  }
  else {
    f = fopen(buf, "r");
    if (f) {
      yyin = f;
      input_stack[input_stack_ptr].buffer_state = YY_CURRENT_BUFFER;
      input_stack[input_stack_ptr].line = line;
      input_stack_ptr++;
      yy_switch_to_buffer(yy_create_buffer(yyin, YY_BUF_SIZE));
      line.number = 1;
      line.include_p = 1;
      line.file_name = safe_strdup(buf);
    }
    else
      err(line, "can't open input '%s'", buf);
  }
  BEGIN(INITIAL);
}
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(inputdirective):
#line 398 "sketch.l"
{
  if (input_stack_ptr == 0) {
    yyterminate();
  }
  else {
    yy_delete_buffer(YY_CURRENT_BUFFER);
    // don't free: refs may still exist for def locs in the symbol table
    // safe_free(line.file_name);
    --input_stack_ptr;
    yy_switch_to_buffer(input_stack[input_stack_ptr].buffer_state);
    line = input_stack[input_stack_ptr].line;
  }
}
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 412 "sketch.l"
{
  die(line, "bad char '%c' (%d)\n", yytext[0], (int)yytext[0]);
}
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 416 "sketch.l"
ECHO;
	YY_BREAK
#line 1533 "lex.yy.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yy_hold_char;
		YY_RESTORE_YY_MORE_OFFSET

		if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between yy_current_buffer and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yy_n_chars = yy_current_buffer->yy_n_chars;
			yy_current_buffer->yy_input_file = yyin;
			yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state();

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer() )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yy_did_buffer_switch_on_eof = 0;

				if ( yywrap() )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yy_c_buf_p =
					yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yy_c_buf_p =
				&yy_current_buffer->yy_ch_buf[yy_n_chars];

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of yylex */


/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

static int yy_get_next_buffer()
	{
	register char *dest = yy_current_buffer->yy_ch_buf;
	register char *source = yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( yy_current_buffer->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		yy_current_buffer->yy_n_chars = yy_n_chars = 0;

	else
		{
		int num_to_read =
			yy_current_buffer->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );
#else

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = yy_current_buffer;

			int yy_c_buf_p_offset =
				(int) (yy_c_buf_p - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yy_flex_realloc( (void *) b->yy_ch_buf,
							 b->yy_buf_size + 2 );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = yy_current_buffer->yy_buf_size -
						number_to_move - 1;
#endif
			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
			yy_n_chars, num_to_read );

		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	if ( yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			yy_current_buffer->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	yy_n_chars += number_to_move;
	yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

	return ret_val;
	}


/* yy_get_previous_state - get the state just before the EOB char was reached */

static yy_state_type yy_get_previous_state()
	{
	register yy_state_type yy_current_state;
	register char *yy_cp;

	yy_current_state = yy_start;

	for ( yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			yy_last_accepting_state = yy_current_state;
			yy_last_accepting_cpos = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 283 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
	}


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

#ifdef YY_USE_PROTOS
static yy_state_type yy_try_NUL_trans( yy_state_type yy_current_state )
#else
static yy_state_type yy_try_NUL_trans( yy_current_state )
yy_state_type yy_current_state;
#endif
	{
	register int yy_is_jam;
	register char *yy_cp = yy_c_buf_p;

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		yy_last_accepting_state = yy_current_state;
		yy_last_accepting_cpos = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 283 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 282);

	return yy_is_jam ? 0 : yy_current_state;
	}


#ifndef YY_NO_UNPUT
#ifdef YY_USE_PROTOS
static void yyunput( int c, register char *yy_bp )
#else
static void yyunput( c, yy_bp )
int c;
register char *yy_bp;
#endif
	{
	register char *yy_cp = yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yy_hold_char;

	if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yy_n_chars + 2;
		register char *dest = &yy_current_buffer->yy_ch_buf[
					yy_current_buffer->yy_buf_size + 2];
		register char *source =
				&yy_current_buffer->yy_ch_buf[number_to_move];

		while ( source > yy_current_buffer->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		yy_current_buffer->yy_n_chars =
			yy_n_chars = yy_current_buffer->yy_buf_size;

		if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;


	yytext_ptr = yy_bp;
	yy_hold_char = *yy_cp;
	yy_c_buf_p = yy_cp;
	}
#endif	/* ifndef YY_NO_UNPUT */


#ifdef __cplusplus
static int yyinput()
#else
static int input()
#endif
	{
	int c;

	*yy_c_buf_p = yy_hold_char;

	if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			/* This was really a NUL. */
			*yy_c_buf_p = '\0';

		else
			{ /* need more input */
			int offset = yy_c_buf_p - yytext_ptr;
			++yy_c_buf_p;

			switch ( yy_get_next_buffer() )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/* fall through */

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap() )
						return EOF;

					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yy_c_buf_p = yytext_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yy_c_buf_p;	/* cast for 8-bit char's */
	*yy_c_buf_p = '\0';	/* preserve yytext */
	yy_hold_char = *++yy_c_buf_p;


	return c;
	}


#ifdef YY_USE_PROTOS
void yyrestart( FILE *input_file )
#else
void yyrestart( input_file )
FILE *input_file;
#endif
	{
	if ( ! yy_current_buffer )
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

	yy_init_buffer( yy_current_buffer, input_file );
	yy_load_buffer_state();
	}


#ifdef YY_USE_PROTOS
void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
#else
void yy_switch_to_buffer( new_buffer )
YY_BUFFER_STATE new_buffer;
#endif
	{
	if ( yy_current_buffer == new_buffer )
		return;

	if ( yy_current_buffer )
		{
		/* Flush out information for old buffer. */
		*yy_c_buf_p = yy_hold_char;
		yy_current_buffer->yy_buf_pos = yy_c_buf_p;
		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	yy_current_buffer = new_buffer;
	yy_load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yy_did_buffer_switch_on_eof = 1;
	}


#ifdef YY_USE_PROTOS
void yy_load_buffer_state( void )
#else
void yy_load_buffer_state()
#endif
	{
	yy_n_chars = yy_current_buffer->yy_n_chars;
	yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
	yyin = yy_current_buffer->yy_input_file;
	yy_hold_char = *yy_c_buf_p;
	}


#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
#else
YY_BUFFER_STATE yy_create_buffer( file, size )
FILE *file;
int size;
#endif
	{
	YY_BUFFER_STATE b;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yy_flex_alloc( b->yy_buf_size + 2 );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
	}


#ifdef YY_USE_PROTOS
void yy_delete_buffer( YY_BUFFER_STATE b )
#else
void yy_delete_buffer( b )
YY_BUFFER_STATE b;
#endif
	{
	if ( ! b )
		return;

	if ( b == yy_current_buffer )
		yy_current_buffer = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yy_flex_free( (void *) b->yy_ch_buf );

	yy_flex_free( (void *) b );
	}


#ifndef YY_ALWAYS_INTERACTIVE
#ifndef YY_NEVER_INTERACTIVE
extern int isatty YY_PROTO(( int ));
#endif
#endif

#ifdef YY_USE_PROTOS
void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
#else
void yy_init_buffer( b, file )
YY_BUFFER_STATE b;
FILE *file;
#endif


	{
	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

#if YY_ALWAYS_INTERACTIVE
	b->yy_is_interactive = 1;
#else
#if YY_NEVER_INTERACTIVE
	b->yy_is_interactive = 0;
#else
	b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
#endif
#endif
	}


#ifdef YY_USE_PROTOS
void yy_flush_buffer( YY_BUFFER_STATE b )
#else
void yy_flush_buffer( b )
YY_BUFFER_STATE b;
#endif

	{
	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == yy_current_buffer )
		yy_load_buffer_state();
	}


#ifndef YY_NO_SCAN_BUFFER
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_buffer( char *base, yy_size_t size )
#else
YY_BUFFER_STATE yy_scan_buffer( base, size )
char *base;
yy_size_t size;
#endif
	{
	YY_BUFFER_STATE b;

	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b );

	return b;
	}
#endif


#ifndef YY_NO_SCAN_STRING
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_string( yyconst char *yy_str )
#else
YY_BUFFER_STATE yy_scan_string( yy_str )
yyconst char *yy_str;
#endif
	{
	int len;
	for ( len = 0; yy_str[len]; ++len )
		;

	return yy_scan_bytes( yy_str, len );
	}
#endif


#ifndef YY_NO_SCAN_BYTES
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_bytes( yyconst char *bytes, int len )
#else
YY_BUFFER_STATE yy_scan_bytes( bytes, len )
yyconst char *bytes;
int len;
#endif
	{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;

	/* Get memory for full buffer, including space for trailing EOB's. */
	n = len + 2;
	buf = (char *) yy_flex_alloc( n );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < len; ++i )
		buf[i] = bytes[i];

	buf[len] = buf[len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
	}
#endif


#ifndef YY_NO_PUSH_STATE
#ifdef YY_USE_PROTOS
static void yy_push_state( int new_state )
#else
static void yy_push_state( new_state )
int new_state;
#endif
	{
	if ( yy_start_stack_ptr >= yy_start_stack_depth )
		{
		yy_size_t new_size;

		yy_start_stack_depth += YY_START_STACK_INCR;
		new_size = yy_start_stack_depth * sizeof( int );

		if ( ! yy_start_stack )
			yy_start_stack = (int *) yy_flex_alloc( new_size );

		else
			yy_start_stack = (int *) yy_flex_realloc(
					(void *) yy_start_stack, new_size );

		if ( ! yy_start_stack )
			YY_FATAL_ERROR(
			"out of memory expanding start-condition stack" );
		}

	yy_start_stack[yy_start_stack_ptr++] = YY_START;

	BEGIN(new_state);
	}
#endif


#ifndef YY_NO_POP_STATE
static void yy_pop_state()
	{
	if ( --yy_start_stack_ptr < 0 )
		YY_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN(yy_start_stack[yy_start_stack_ptr]);
	}
#endif


#ifndef YY_NO_TOP_STATE
static int yy_top_state()
	{
	return yy_start_stack[yy_start_stack_ptr - 1];
	}
#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

#ifdef YY_USE_PROTOS
static void yy_fatal_error( yyconst char msg[] )
#else
static void yy_fatal_error( msg )
char msg[];
#endif
	{
	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
	}



/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void yy_flex_strncpy( char *s1, yyconst char *s2, int n )
#else
static void yy_flex_strncpy( s1, s2, n )
char *s1;
yyconst char *s2;
int n;
#endif
	{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
	}
#endif

#ifdef YY_NEED_STRLEN
#ifdef YY_USE_PROTOS
static int yy_flex_strlen( yyconst char *s )
#else
static int yy_flex_strlen( s )
yyconst char *s;
#endif
	{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
	}
#endif


#ifdef YY_USE_PROTOS
static void *yy_flex_alloc( yy_size_t size )
#else
static void *yy_flex_alloc( size )
yy_size_t size;
#endif
	{
	return (void *) malloc( size );
	}

#ifdef YY_USE_PROTOS
static void *yy_flex_realloc( void *ptr, yy_size_t size )
#else
static void *yy_flex_realloc( ptr, size )
void *ptr;
yy_size_t size;
#endif
	{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
	}

#ifdef YY_USE_PROTOS
static void yy_flex_free( void *ptr )
#else
static void yy_flex_free( ptr )
void *ptr;
#endif
	{
	free( ptr );
	}

#if YY_MAIN
int main()
	{
	yylex();
	return 0;
	}
#endif
#line 416 "sketch.l"


void set_lexer_file(char *file_name, FILE *f)
{
  line.file_name = safe_strdup(file_name);
  line.include_p = 0;
  line.number = 1;
  yyin = f;
}
